extends ../_docs-template

block vars
  - var title = 'Cards | Framework7 Documentation';

block docs-index

block content


  .docs-nav
    include ../_docs-menu
  .docs-content
    .motion-docs-page-title
      h1 Cards
      script(src="/js/motion/card.js")
      f7-motion-card(motion)

    p Cards, along with List View, is a great way to contain and organize your information. Cards contain unique related data, for example, a photo, text, and link all about a single subject. Cards are typically an entry point to more complex and detailed information.
    h2 Card Layout
    p Lets look at a basic card HTML layout
    :code(lang="html")
          <div class="card">
            <div class="card-header">Header</div>
            <div class="card-content">
              <!-- Card content -->
            </div>
            <div class="card-footer">Footer</div>
          </div>

          <div class="card card-raised">
            <div class="card-header">Header</div>
            <div class="card-content card-content-padding">
              <!-- Card content -->
            </div>
            <div class="card-footer">Footer</div>
          </div>

          <div class="card card-outline card-header-divider card-footer-divider">
            <div class="card-header">Header</div>
            <div class="card-content">
              <!-- Card content -->
            </div>
            <div class="card-footer">Footer</div>
          </div>
    p Where:
    ul
      li
        p `<div class="card">` - Card container
        ul
          li
            p `<div class="card-header">` - Card header. Mostly used to display card title. Optional
          li
            p `<div class="card-footer">` - Card footer is used for some additional information or for custom actions/links. Optional
          li
            p `<div class="card-content">` - Main container for card content. Required
          li
            p `<div class="card-content card-content-padding">` - Additional <b>card-content-padding</b> used to add extra padding to card-content
          li
            p `card-raised` - additional class that can be added to card element to make card raised - with shadow
          li
            p `card-outline` - additional class that can be added to card element to make it outline (add border)
          li
            p `card-header-divider` - additional class that can be added to card element to add divider (border) after card header element
          li
            p `card-footer-divider` - additional class that can be added to card element to add divider (border) before card footer element
    .important-note
      p Note that "card-header" and "card-footer" have a flexbox layout (<em>display:flex</em>) where as items have a center vertical alignment. If you need to align items to top or to bottom of header/footer, then you may use additional <a href="typography.html">typography</a> classes, for example:
      p <b>&lt;div class="card-header align-items-flex-start"&gt;</b> - align header items by header top line
      p <b>&lt;div class="card-footer align-items-flex-end"&gt;</b> - align footer items by footer bottom line

    h2 Expandable Cards
    p Expandable Cards (aka AppStore cards) is a subset of usual Cards which expand on click to full screen size on mobile and to larger size on tablet.
    h4 Expandable Cards Layout
    p It has a bit different and simplified layout:
    :code(lang="html")
      <!-- addition "card-expandable" class on card to make it expandable -->
      <div class="card card-expandable">
        <!-- card content -->
        <div class="card-content">
          <!-- put all content here -->
        </div>
      </div>
    p Where
      ul
        li `card-expandable` - addition class on card element to make it expandable
        li `card-content` - only place here to put any card content
    p So all the extra elements like `card-content-padding`, `card-header`, `card-footer` must be placed inside of `card-content` when card is expandable.

    h4 Expandable Card Size
    p By default expandable card opens to fixed size on tablet/desktops. To make expandable card to open to full screen size on tablet/desktop screen additional `card-tablet-fullscreen` class required on card element. Otherwise you can configure this size using `--f7-card-expandable-tablet-width` and `--f7-card-expandable-tablet-height` CSS variables.
    p Expandable card content (`card-content`) is set to `100vw` width when collapsed (closed). It is done to improve card open/close transition performance, so you need to take care about its content positioning. You can make its content width also animatable and responsive by adding additional `card-expandable-animate-width` class to card element, but performance can be worse in this case.

    h4 Hide Elements On Open/Close
    p Expandable card has 2 states: closed and opened. And it is possible to hide/show card's elements by using these two classes:
    ul
      li `card-opened-fade-in` - element with such class inside of card-content will have `0` opacity when card closed, and it will fade to `1` opacity on card open.
      li `card-opened-fade-out` - element with such class inside of card-content will have `1` opacity when card closed, and it will fade to `0` opacity on card open.

    h4 Prevent Card From Opening
    p In some layouts you may have a button or link in visible area or expandable card when it is collapsed. To allow click on such button or link and to prevent expandable card from opening, we need to add `card-prevent-open` class to this button:

    :code(lang="html")
      <div class="card card-expandable">
        <div class="card-content">
          ...
          <!-- Add "card-prevent-open" to element and click on it won't open expandable card -->
          <a href="#" class="button card-prevent-open">Button</a>
        </div>
      </div>

    h4 Expandable Card Backdrop
    p If you have enabled expandable card backdrop (enabled by default, see parameters below), then it will automatically add backdrop element (darken overlay behind the card) on card open to card parent page.
    p In some layouts you may need to place such backdrop element in custom place. In this case we need to manually add this element and specify it in card's `data-backdrop-el` attribute:
    :code(lang="html")
      <div class="block">
        <!-- custom backdrop element -->
        <div class="card-backdrop custom-backdrop"></div>
        <!-- pass its CSS selector in data-backdrop-el attribute -->
        <div class="card card-expandable" data-backdrop-el=".custom-backdrop">
          ...
        </div>
      </div>


    h2 Card App Methods
    p Let's look at related App methods to work with expandable cards:
    .method-wrap
      p
        span.method app.card.open(<span>el</span>, <span>animate</span>)
        | - open expandable card
      ul.method-parameters
        li
          span.parameter el
          |  - <span class="parameter-type">HTMLElement</span> or <span class="parameter-type">string</span> (with CSS Selector). Expandable card to open.
        li
          span.parameter animate
          |  - <span class="parameter-type">boolean</span>. Opens expandable card with animation. By default is `true`
    .method-wrap
      p
        span.method app.card.close(<span>el</span>, <span>animate</span>)
        | - close expandable card
      ul.method-parameters
        li
          span.parameter el
          |  - <span class="parameter-type">HTMLElement</span> or <span class="parameter-type">string</span> (with CSS Selector). Expandable card to close.
        li
          span.parameter animate
          |  - <span class="parameter-type">boolean</span>. Closes expandable card with animation. By default is `true`

    .method-wrap
      p
        span.method app.card.toggle(<span>el</span>, <span>animate</span>)
        | - toggle expandable card
      ul.method-parameters
        li
          span.parameter el
          |  - <span class="parameter-type">HTMLElement</span> or <span class="parameter-type">string</span> (with CSS Selector). Expandable card to toggle.
        li
          span.parameter animate
          |  - <span class="parameter-type">boolean</span>. Toggle expandable card with animation. By default is `true`

    h2 Card App Parameters
    p It is possible to control some default Cards behavior using global <a href="app.html#app-parameters">app parameters</a> by passing Cards related parameters under `card` parameter:
    table.params-table
      thead
        tr
          th Parameter
          th Type
          th Default
          th Description
      tbody
        tr
          td hideNavbarOnOpen
          td boolean
          td true
          td Will hide Navbar on expandable card open.
        tr
          td hideToolbarOnOpen
          td boolean
          td true
          td Will hide Toolbar on expandable card open.
        tr
          td hideStatusbarOnOpen
          td boolean
          td true
          td Will hide "Statusbar" (or fully hide Navbar) on expandable card open.
        tr
          td swipeToClose
          td boolean
          td true
          td Allows to close expandable card with swipe.
        tr
          td backdrop
          td boolean
          td true
          td Enables expandable card backdrop layer.
        tr
          td closeByBackdropClick
          td boolean
          td true
          td When enabled, expandable card will be closed on its backdrop click.
    p For example:
    :code(lang="js")
      var app = new Framework7({
        card: {
          hideNavbarOnOpen: false,
          closeByBackdropClick: false,
        },
      });
    p In addition, all these paramteres can be set on each expandable card individually with same `data-` attributes, including additional `data-animate` attribute:
    :code(lang="html")
      <!-- this card will opened without animation -->
      <div class="card card-expandable" data-animate="false">
        ...
      </div>

      <!-- this card will opened without backdrop -->
      <div class="card card-expandable" data-backdrop="false">
        ...
      </div>
    h2 Control Cards With Links
    p It is possible to open and close required expandable cards using special classes and data attributes on links:
    .important-note
      ul
        li
          p To open expandable card we need to add "<b>card-open</b>" class to any HTML element (preferred to link)
        li
          p To close expandable we need to add "<b>card-close</b>" class to any HTML element (preferred to link)
        li
          p If you have more than one expandable cards in DOM, you need to specify appropriate card via additional <b>data-card=".my-card"</b> attribute on this HTML element

    h2 Card Events
    p Expandable card will fire the following DOM events on card element and events on app instance:
    h3 DOM Events
    table.events-table
      thead
        tr
          th Event
          th Target
          th Description
      tbody
        tr
          td card:beforeopen
          td Card Element<span>&lt;div class="card"&gt;</span>
          td Event will be triggered right before expandable card starts its opening animation. `event.detail.prevent` contains function that will prevent card from opening when called
        tr
          td card:open
          td Card Element<span>&lt;div class="card"&gt;</span>
          td Event will be triggered when expandable card starts its opening animation
        tr
          td card:opened
          td Card Element<span>&lt;div class="card"&gt;</span>
          td Event will be triggered after expandable card completes its opening animation
        tr
          td card:close
          td Card Element<span>&lt;div class="card"&gt;</span>
          td Event will be triggered when expandable card starts its closing animation
        tr
          td card:closed
          td Card Element<span>&lt;div class="card"&gt;</span>
          td Event will be triggered after expandable card completes its closing animation
    h3 App Instance Events
    table.events-table
      thead
        tr
          th Event
          th Arguments
          th Description
      tbody
        tr
          td cardBeforeOpen
          td <span>(el, prevent)</span>
          td Event will be triggered right before expandable card starts its opening animation. `prevent` contains function that will prevent expandable card from opening when called
        tr
          td cardOpen
          td <span>(el)</span>
          td Event will be triggered when expandable card starts its opening animation. As an argument event handler received card HTML element
        tr
          td cardOpened
          td <span>(el)</span>
          td Event will be triggered after expandable card completes its opening animation. As an argument event handler received card HTML element
        tr
          td cardClose
          td <span>(el)</span>
          td Event will be triggered when expandable card starts its closing animation. As an argument event handler received card HTML element
        tr
          td cardClosed
          td <span>(el)</span>
          td Event will be triggered after expandable card completes its closing animation. As an argument event handler received card HTML element


    +cssVars('card')


    h2 Examples
    +examplePreview('core', 'cards.html', 'cards')
    +examplePreview('core', 'cards-expandable.html', 'cards-expandable')
